;
;					EJEMPLO 1.5
;
;				Autor: Mikel Etxebarria
;			(c) Microsystems Engineering (Bilbao)
;
;Ejemplo para simulacin
;
;Almacenar el patrn 33 en 15 posiciones contiguas de la memoria de datos, empezando desde
;la direccin 0x10
		
		List	p=16F84		;Tipo de procesador
		include	"P16F84.INC"	;Definiciones de registros internos

Contador	equ	0x0c		;Contador interno
Primera		equ	0x10		;Posicin inicial

		org	0x00		;Vector de Reset
		goto	Inicio

		org	0x05		;Salva el vector de interrupcin

Inicio		movlw	.15
		movwf	Contador	;Carga el contador con 15 (en decimal)
		movlw	Primera
		movwf	FSR		;Inicia puntero con direccin inicial
		movlw	0x33		;Carga patrn a almacenar

Bucle		movwf	INDF		;Almacena patrn en pos. indicada por FSR
		incf	FSR,F		;Incrementa el puntero FSR
		decfsz	Contador,F	;Decrementa contador hasta llegar a 0
		goto	Bucle		;Contador no es 0

Stop		nop			;Poner breakpoint de parada
		nop

		end			;Fin del programa fuente
