;
;					EJEMPLO 2.1
;
;				Autor: Mikel Etxebarria
;			(c) Microsystems Engineering (Bilbao)
;
;Ejemplo para simulacin y/o MicroPIC Trainer
;
;Leer el estado de los 5 interruptores de la Trainer (RA4-RA0) y reflejar el nivel
;lgico de los mismos sobre los leds RB4-RB7 conectados a la puerta B
		
		List	p=16F84		;Tipo de procesador
		include	"P16F84.INC"	;Definiciones de registros internos


		org	0x00		;Vector de Reset
		goto	Inicio

		org	0x05		;Salva el vector de interrupcin

Inicio	        clrf 	PORTB		;Borra los latch de salida
		bsf	STATUS,RP0	;Selecciona banco 1
		clrf	TRISB		;Puerta B se configura como salida
		movlw	b'00011111'		
		movwf	TRISA		;Puerta A se configura como entrada
		bcf	STATUS,RP0	;Selecciona banco 0

Loop		movf	PORTA,W		;Leer las entradas RA0-RA4
		movwf	PORTB		;Reflejar en las salidas
		goto	Loop		;Bucle sin fin

Stop		nop	   		;Poner breakpoint de parada
		nop

		end			;Fin del programa fuente
